# Documentation

 This is more a techincal documentation that how to use this tool.

# Install

Please refer to the README file, all install steps are described.

## Pipx

Not refered in the install, but you can pipx for you install.

# Virtual Server Creation

## Linux

For the moment, no issue with tested distribution:
  - Archlinux
  - Debian/ubuntu
  - Centos/Fedora/Redhat
  - FreeBSD
  - TinyCore

## Other install

Tested succeffully :
  - Pfsense,Dynfi,Open

## Windows

Windows OS will need some extra-drivers to run on virtualized server.

For this during the install, the VM will need a virtIO-win iso with all drivers.
The VirtIO iso is already mounted as a CD-ROM on VM creation. Load the drivers according to you OS install.

### VirtIO

VirtIO is a QEMU drivers for Windows OS (please read : https://developer.ibm.com/articles/l-virtio/)

VirtIO can be found here :
https://fedorapeople.org/groups/virt/virtio-win/direct-downloads/archive-virtio/?C=M;O=D

Take care of the version, some virtio are not compatible with some Windows version.

This iso is on ./storage/win/ and configured in **config.py** for upgrade.

### Tested Windows Installation (tested with Virtio 0.1.229):

Validate for :
  - Windows 8, 8,1 10
  - Windows Server 2019, 2022

Failed with :
  - Windows 98, Windows XP, Windows 11 (UEFI access)

Never Tested :
  - Win 7 and Vista


# ERROR and SOLUTION

You may incounter some error in specific case, please report them if they are not in the list,
They will be consider on nexts releases.

ERROR: Error destroying Requested operation is not valid: cannot undefine domain with nvram :
SOLUTION (on CLI): virsh undefine --nvram VM_NAME

ERROR: Error stoping NOM_VM:Requested operation is not valid: domain is not running
SOLUTION 1 (on CLI): virsh reset VM_NAME
SOLUTION 2 (on CLI): virsh destroy VM_NAME (destroy the VM)
